﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using C1.Win.C1FlexGrid;
using System.Runtime.InteropServices;

namespace Prj_FilterEditorForm
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            c1FlexGrid1.Cols.Count = 5;
            c1FlexGrid1.Rows.Count = 20;
            for (int row = c1FlexGrid1.Rows.Fixed; row < c1FlexGrid1.Rows.Count; row++)
                for (int col = c1FlexGrid1.Cols.Fixed; col < c1FlexGrid1.Cols.Count; col++)
                {
                    c1FlexGrid1[row, col] = string.Format("Cell[{0}, {1}] This is a test to check the functionality related to Filter", row, col);
                }

            c1FlexGrid1.AllowFiltering = true;
            c1FlexGrid1.RightToLeft = RightToLeft.Yes;
            c1FlexGrid1.MouseClick += C1FlexGrid1_MouseClick;
        }

        enum ScrollBarCommands
        {
            SB_LINEUP = 0,
            SB_LINELEFT = 0,
            SB_LINEDOWN = 1,
            SB_LINERIGHT = 1,
            SB_PAGEUP = 2,
            SB_PAGELEFT = 2,
            SB_PAGEDOWN = 3,
            SB_PAGERIGHT = 3,
            SB_THUMBPOSITION = 4,
            SB_THUMBTRACK = 5,
            SB_TOP = 6,
            SB_LEFT = 6,
            SB_BOTTOM = 7,
            SB_RIGHT = 7,
            SB_ENDSCROLL = 8
        }

        /// <summary>
        /// Windows Messages
        /// Defined in winuser.h from Windows SDK v6.1
        /// Documentation pulled from MSDN.
        /// </summary>
        enum WM : uint
        {
            /// <summary>
            /// The WM_HSCROLL message is sent to a window when a scroll event occurs in the window's standard horizontal scroll bar. This message is also sent to the owner of a horizontal scroll bar control when a scroll event occurs in the control. 
            /// </summary>
            HSCROLL = 0x0114,
            /// <summary>
            /// The WM_VSCROLL message is sent to a window when a scroll event occurs in the window's standard vertical scroll bar. This message is also sent to the owner of a vertical scroll bar control when a scroll event occurs in the control. 
            /// </summary>
            VSCROLL = 0x0115
        }

        [DllImport("user32.dll", CharSet = CharSet.Auto)]
        private static extern int SendMessage(IntPtr hWnd, int wMsg, IntPtr wParam, IntPtr lParam);

        private void C1FlexGrid1_MouseClick(object sender, MouseEventArgs e)
        {
            if (c1FlexGrid1.HitTest(e.Location).Type == HitTestTypeEnum.FilterIcon)
            {
                foreach (Form frm in Application.OpenForms)
                {
                    if (frm.Name == "FilterEditorForm" && frm.GetType().ToString() == "C1.Win.C1FlexGrid.FilterEditorForm")
                    {
                        var list = frm.Controls[1].Controls[1].Controls[0];
                        list.GetType().GetProperty("BoldCheckedItems").SetValue(list, false);
                        list.Font = new Font(list.Font, FontStyle.Italic);
                        SendMessage(list.Handle, (int)WM.HSCROLL, (IntPtr)ScrollBarCommands.SB_RIGHT, IntPtr.Zero);
                    }
                }
            }
        }
    }
}
